#ifndef INC_LangParser_hpp_
#define INC_LangParser_hpp_

#include <antlr/config.hpp>
/* $ANTLR 2.7.5 (20050128): "treewalk.g" -> "LangParser.hpp"$ */
#include <antlr/TokenStream.hpp>
#include <antlr/TokenBuffer.hpp>
#include "LangParserTokenTypes.hpp"
#include <antlr/LLkParser.hpp>

#line 1 "treewalk.g"

#include "MyAST.h"

#line 16 "LangParser.hpp"
class CUSTOM_API LangParser : public ANTLR_USE_NAMESPACE(antlr)LLkParser, public LangParserTokenTypes
{
#line 1 "treewalk.g"
#line 20 "LangParser.hpp"
public:
	void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
protected:
	LangParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k);
public:
	LangParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf);
protected:
	LangParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k);
public:
	LangParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer);
	LangParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state);
	int getNumTokens() const
	{
		return LangParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return LangParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return LangParser::tokenNames;
	}
	public: void block();
	public: void statement();
	public: void expr();
	public: void assignExpr();
	public: void aexpr();
	public: void mexpr();
	public: void atom();
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST);
	}
	
protected:
	RefMyAST returnAST;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 21;
#else
	enum {
		NUM_TOKENS = 21
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_2;
	static const unsigned long _tokenSet_3_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_3;
	static const unsigned long _tokenSet_4_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_4;
	static const unsigned long _tokenSet_5_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_5;
};

#endif /*INC_LangParser_hpp_*/
