#ifndef INC_LangWalker_hpp_
#define INC_LangWalker_hpp_

#include <antlr/config.hpp>
#include "LangParserTokenTypes.hpp"
/* $ANTLR 2.7.5 (20050128): "treewalk.g" -> "LangWalker.hpp"$ */
#include <antlr/TreeParser.hpp>

#line 1 "treewalk.g"

#include "MyAST.h"

#line 14 "LangWalker.hpp"
class CUSTOM_API LangWalker : public ANTLR_USE_NAMESPACE(antlr)TreeParser, public LangParserTokenTypes
{
#line 71 "treewalk.g"

	void printAST( RefMyAST ast );
#line 18 "LangWalker.hpp"
public:
	LangWalker();
	static void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
	int getNumTokens() const
	{
		return LangWalker::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return LangWalker::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return LangWalker::tokenNames;
	}
	public: void block(RefMyAST _t);
	public: void stat(RefMyAST _t);
	public: void expr(RefMyAST _t);
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST);
	}
	
protected:
	RefMyAST returnAST;
	RefMyAST _retTree;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 21;
#else
	enum {
		NUM_TOKENS = 21
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
};

#endif /*INC_LangWalker_hpp_*/
